cbuffer data :register(b0)
{
	float4x4 transform;
};


Texture2D diffuseMap;

SamplerState textureSampler
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

struct VS_INPUT
{
    float4 position : POSITION;
    float2 tex : TEXCOORD;
};

struct VS_OUTPUT
{
    float4 position : SV_POSITION;
    float2 tex: TEXCOORD;
};


VS_OUTPUT VSMain( VS_INPUT input )
{
    VS_OUTPUT Output;
    Output.position = mul(transform,input.position );
    Output.tex=input.tex;
    return Output;
}

float4 PSMain( VS_OUTPUT input ) : SV_TARGET
{
	return diffuseMap.Sample(textureSampler,input.tex);
}
