#include "ConstantBuffer.h"

ConstantBuffer::ConstantBuffer()
{
	
}

ConstantBuffer* ConstantBuffer::Init(DeviceManager* manager,int size)
{
	ConstantBuffer* c=new ConstantBuffer();

	c->devicePointer=manager;
	D3D11_BUFFER_DESC bd;
	bd.Usage = D3D11_USAGE_DYNAMIC;
	bd.ByteWidth = size;
	bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	bd.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
	bd.MiscFlags = 0;
	HRESULT hr=c->devicePointer->device->CreateBuffer( &bd, NULL, &c->buffer );
	if(hr!=S_OK)
	{
		delete c;
		return NULL;
	}
	return c;
}

void ConstantBuffer::Release()
{
	SAFE_RELEASE(buffer);
}

void ConstantBuffer::Write(LPVOID source,int size)
{
	D3D11_MAPPED_SUBRESOURCE subRes;
	HRESULT hr = devicePointer->context->Map(buffer,0,D3D11_MAP_WRITE_DISCARD,0,&subRes);
	if(hr==S_OK)
	{
		memcpy_s( subRes.pData,size,source,size);
	}
	devicePointer->context->Unmap(buffer,0);
}

ID3D11Buffer* ConstantBuffer::GetBufferPointer()
{
	return buffer;
}