#pragma once
#include "AllInclude.h"

class DeviceManager
{
private:
	DeviceManager();
public:
	static DeviceManager* CreateDevice(int width,int height,bool fullscreen,HWND handle);
	bool Resize(int width,int height);
	void SetViewport(int width, int height);
	void RestoreTarget();
	void Clear(float r,float g,float b,float a);
	void Present();
	void Release();
	int GetWidth();
	int GetHeight();

	ID3D11Device* device;
	ID3D11DeviceContext* context;
	IDXGISwapChain* swapChain;
	ID3D11Texture2D* pBackBuffer;
	ID3D11RenderTargetView* renderTargetView;
	ID3D11DepthStencilView* renderTargetDepth;   

private:
	ID3D11DepthStencilState* depthState;
	ID3D11RasterizerState* rasterState;
	ID3D11SamplerState* samplerState;
	ID3D11BlendState* blendState;
	bool CreateTargetView();
	bool CreateDepthStencilView(int width,int height);
	bool isFullscreen;
	int width;
	int height;
};
