#pragma once
#include "DeviceManager.h"

enum ShaderTarget
{
	Target_VertexShader,
	Target_PixelShader,
	Target_GeometryShader,
	Target_HullShader,
	Target_DomainShader,
};

class EffectManager
{
public:
	EffectManager();
	static EffectManager* Init(DeviceManager* device,char* filename,char* vertexShaderEntry, char* pixelShaderEntry, char* geometryShaderEntry,char* domainShaderEntry,char* hullShaderEntry,bool model5);
	void Release();

	LPVOID GetByteCodeBufferPointer();
	int GetByteCodeBufferSize();

	void Apply();

private:

	DeviceManager* devicePointer;
	bool Compile(char* filename,char* entryPoint,ShaderTarget target,bool model5);

	LPVOID vertexByteCode;
	int vertexByteSize;

	ID3D11VertexShader* vertexShader;
	ID3D11PixelShader* pixelShader;
	ID3D11GeometryShader* geometryShader;
	ID3D11HullShader* hullShader;
	ID3D11DomainShader* domainShader;
	
};
