#include "windows.h"
#include "stdio.h"
#include "resource.h"
#include "TutorialApplication.h"

BaseApplication* dxApplication;

LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    PAINTSTRUCT ps;
    HDC hdc;

    switch (msg) 
    {
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            EndPaint(hWnd, &ps);
			
            break;

        case WM_DESTROY:
            PostQuitMessage(0);
            break;
		case WM_SIZE:
			RECT rect;
			GetClientRect(hWnd,&rect);
			dxApplication->Reset(rect.right-rect.left,rect.bottom-rect.top);
			break;
		case WM_KEYDOWN:
			dxApplication->DoCommand(wParam);
        default:
            return DefWindowProc(hWnd, msg, wParam, lParam);
    }

    return 0;
}




//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE instance, LPSTR, INT )
{
	//WCHAR title[256]="Ciao";

	//wsprintfW(title,L"%s VRAM: %d MB",desc.Description,memory );

	HICON icon =  LoadIcon(GetModuleHandle(NULL),
                         MAKEINTRESOURCE(IDI_ICON1));


    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, MsgProc, 0L, 0L, 
                      hInst,icon , LoadCursor(NULL,IDC_ARROW), NULL, NULL,
                      L"DirectX10", NULL };
	
	RegisterClassEx( &wc );

	//create the form
	//crea la finestra
    HWND hWnd = CreateWindow(L"DirectX10",L"Tutorial", 
                              WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 1024, 768,
                              NULL, NULL, NULL, NULL );

	//costruttore
	RECT rect;
	GetClientRect(hWnd,&rect);
	dxApplication=new TutorialApplication(rect.right- rect.left,rect.bottom-rect.top,hWnd, false);

	if(!dxApplication->Init())
	{
		dxApplication->Release();
		return 0;
	}

    ShowWindow( hWnd, SW_SHOWDEFAULT );

	MSG msg={0}; 
    while( WM_QUIT != msg.message )
    {
        if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
        {
            TranslateMessage( &msg );
            DispatchMessage( &msg );
        }
        else
        {
            dxApplication->Render();
			//break;
        }
    }
	dxApplication->Release();

    UnregisterClass( L"DirectX10", wc.hInstance );
    return 0;

}
